Part Circle: Difference between revisions

From FreeCAD Documentation
(Undo revision 1222561 by David69 (talk)The command name is "Part_Primitives".)
Tag: Undo
 
(14 intermediate revisions by 2 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
{{UnfinishedDocu{{#translation:}}}}
<translate>
<translate>


Line 17: Line 16:
|Name=Part Circle
|Name=Part Circle
|MenuLocation=Part → [[Part_Primitives|Create primitives]] → Circle
|MenuLocation=Part → [[Part_Primitives|Create primitives]] → Circle
|Workbenches=[[Part_Workbench|Part]]
|Workbenches=[[Part_Workbench|Part]], [[OpenSCAD_Workbench|OpenSCAD]]
|SeeAlso=
|SeeAlso=[[Part_Primitives|Part Primitives]]
}}
}}


Line 24: Line 23:


<!--T:6-->
<!--T:6-->
A [[Image:Part_Circle.svg|24px]] '''Part Circle''' is a parametric shape that can be created with the [[Image:Part_Primitives.svg|24px]] [[Part_Primitives|Part Primitives]] command. In the coordinate system defined by its {{PropertyData|Placement}} property, the circle lies on the XY plane with its center at the origin.
The [[Image:Part_Circle.svg|24px]] [[Part_Circle|Part Circle]] command creates a parametric circle shape.


<!--T:14-->
FreeCAD creates a circle, with default values for the radius and two angles.
A Part Circle is in fact a closed counterclockwise circular arc, it can be turned into an arc by changing its {{PropertyData|Angle1}} and/or {{PropertyData|Angle2}} properties.


</translate>
By default, the circle is positioned with its center at the origin (0,0,0). It lays on the xy-plane.
[[Image:Part_Circle_Example.png|400px]]
<translate>


==Usage== <!--T:11-->
[[File:Part Circle Example.png|Screenshot of Part Circle]]


==Usage== <!--T:11-->
<!--T:15-->
See [[Part_Primitives#Usage|Part Primitives]].


<!--T:5-->
<!--T:16-->
A Part Circle can alternatively be created by selecting three points:
# There are several ways to invoke the command:
#* Press the {{Button|[[Image:Part_Primitives.svg|16px]] [[Part Primitives|Create Primitives...]]}} button.
# In the task panel of the [[Image:Part_Primitives.svg|16px]] [[Part_Primitives|Part Primitives]] command select the {{MenuCommand|[[Image:Part_Circle.svg|16px]] Circle}} option from the dropdown list.
# Press the {{Button|From three points}} button.
#* Select the {{MenuCommand|Part → Create Primitives → [[Image:Part_Primitives.svg|16px]] Create Primitives...}} option from the menu.
# Select three vertices in the [[3D_view|3D view]]. There is no need to hold down the {{KEY|Ctrl}} key.
#* Select the {{MenuCommand|[[Image:Part_Circle.svg|16px]] Circle}} option from the menu.
# A circle is created.
# Set options and press {{Button|Create}}.
# The selected vertices are only used at creation time to calculate the {{PropertyData|Radius}} and {{PropertyData|Placement}} of the circle.
# To close the dialog press {{Button|Close}}.


== Example ==
== Example == <!--T:17-->


<!--T:18-->
[[File:Part Circle Scripting Example.png|thumb|Part Circle scripting example]]
[[Image:Part_Circle_Scripting_Example.png|thumb|Part Circle from the scripting example]]


<!--T:19-->
A Part Circle object with the values of the bottom scripting example are shown here.
A Part Circle object created with the [[#Scripting|scripting example]] below is shown here.

== Notes ==

This command will create a circular curved edge. With the default values, the circular curved edge will be closed and therefore will be a circle. If the properties Angle 0 or Angle 1 are changed from their default values (0 and 360) the edge will be an open curve, an arc.

<!--T:7-->
Alternatively a Part Circle can be initially defined from three points. Once created the circle will only contain the standard Part Circle properties and will no longer contain a reference to the creation points.


==Properties== <!--T:2-->
==Properties== <!--T:2-->


<!--T:20-->
See also: [[Property_editor|Property editor]].
See also: [[Property_editor|Property editor]].


<!--T:21-->
A Part Circle object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:
A Part Circle object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:


=== Data ===
=== Data === <!--T:22-->


<!--T:23-->
{{TitleProperty|Attachment}}

<!--T:24-->
The object has the same attachment properties as a [[Part_Part2DObject#Data|Part Part2DObject]].

<!--T:25-->
{{TitleProperty|Base}}
{{TitleProperty|Base}}

<!--T:8-->
<!--T:8-->
* {{PropertyData|Radius|Length}}: The radius of the curved edge (arc or circle)
* {{PropertyData|Radius|Length}}: The radius of the circle or circular arc. The default is {{Value|2mm}}.
* {{PropertyData|Angle 0|Angle}}}: Start of the curved edge, (degrees counter-clockwise), the default value is 0°
* {{PropertyData|Angle1|Angle}}: The start angle of the circular arc. Valid range: {{Value|0° &lt; value &lt;&#61; 360°}}. The default is {{Value|}}.
* {{PropertyData|Angle2|Angle}}: The end angle of the circular arc. Valid range: {{Value|0° &lt; value &lt;&#61; 360°}}. The default is {{Value|360°}}. If {{PropertyData|Angle1}} and {{PropertyData|Angle2}} are equal, or if one angle is {{Value|0°}} and the other {{Value|360°}}, a full circle is created.
* {{PropertyData|Angle 1|Angle}}}: End of the curved edge, (degrees counter-clockwise), the default value is 360°


==Scripting==
== Scripting == <!--T:26-->


<!--T:27-->
A Part Circle is created with the {{Incode|addObject()}} method of the document.
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation], [[Part_scripting|Part scripting]] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].

<!--T:28-->
A Part Circle can be created with the {{Incode|addObject()}} method of the document:


</translate>
</translate>
Line 79: Line 91:
<translate>
<translate>


<!--T:29-->
* Where {{Incode|myCircle}} is the name for the object. The name must be unique for the entire document.
* Where {{Incode|"myCircle"}} is the name for the object.
* The function returns the newly created object.
* The function returns the newly created object.


<!--T:30-->
The {{Incode|Label}} is the user editable name for the object. It can be easily changed by
Example:


</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD as App
circle.Label = "new myCircleName"
}}
<translate>


doc = App.activeDocument()
You can access and modify attributes of the {{Incode|circle}} object. For example, you may wish to modify the radius or the two angle parameters.


circle = doc.addObject("Part::Circle", "myCircle")
</translate>
{{Code|code=
circle.Radius = 10
circle.Radius = 10
circle.Angle1 = 45
circle.Angle1 = 45
circle.Angle2 = 225
circle.Angle2 = 225
circle.Placement = App.Placement(App.Vector(1, 2, 3), App.Rotation(30, 45, 10))

doc.recompute()
}}
}}
<translate>
<translate>


The result will be a 45 degree rotated semicircle with a radius of 10.

You can change its placement and orientation with:

</translate>
{{Code|code=
circle.Placement = FreeCAD.Placement(FreeCAD.Vector(1, 2, 3), FreeCAD.Rotation(30, 45, 10))
}}
<translate>


<!--T:13-->
<!--T:13-->
Line 121: Line 126:


</translate>
</translate>
{{Part Tools navi{{#translation:}}}}
{{Part_Tools_navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 11:52, 21 January 2023

Part Circle

Menu location
Part → Create primitives → Circle
Workbenches
Part, OpenSCAD
Default shortcut
None
Introduced in version
-
See also
Part Primitives

Description

A Part Circle is a parametric shape that can be created with the Part Primitives command. In the coordinate system defined by its DataPlacement property, the circle lies on the XY plane with its center at the origin.

A Part Circle is in fact a closed counterclockwise circular arc, it can be turned into an arc by changing its DataAngle1 and/or DataAngle2 properties.

Usage

See Part Primitives.

A Part Circle can alternatively be created by selecting three points:

  1. In the task panel of the Part Primitives command select the Circle option from the dropdown list.
  2. Press the From three points button.
  3. Select three vertices in the 3D view. There is no need to hold down the Ctrl key.
  4. A circle is created.
  5. The selected vertices are only used at creation time to calculate the DataRadius and DataPlacement of the circle.

Example

Part Circle from the scripting example

A Part Circle object created with the scripting example below is shown here.

Properties

See also: Property editor.

A Part Circle object is derived from a Part Feature object and inherits all its properties. It also has the following additional properties:

Data

Attachment

The object has the same attachment properties as a Part Part2DObject.

Base

  • DataRadius (Length): The radius of the circle or circular arc. The default is 2mm.
  • DataAngle1 (Angle): The start angle of the circular arc. Valid range: 0° < value <= 360°. The default is .
  • DataAngle2 (Angle): The end angle of the circular arc. Valid range: 0° < value <= 360°. The default is 360°. If DataAngle1 and DataAngle2 are equal, or if one angle is and the other 360°, a full circle is created.

Scripting

See also: Autogenerated API documentation, Part scripting and FreeCAD Scripting Basics.

A Part Circle can be created with the addObject() method of the document:

circle = FreeCAD.ActiveDocument.addObject("Part::Circle", "myCircle")
  • Where "myCircle" is the name for the object.
  • The function returns the newly created object.

Example:

import FreeCAD as App

doc = App.activeDocument()

circle = doc.addObject("Part::Circle", "myCircle")
circle.Radius = 10
circle.Angle1 = 45
circle.Angle2 = 225
circle.Placement = App.Placement(App.Vector(1, 2, 3), App.Rotation(30, 45, 10))

doc.recompute()